             page   80,132

             title  <<<<<<<<  INT 15H  TEST >>>>>>>>>

             include \myasm\ifdo7.asm
             include key_equ.asm

             .list
;
; equates
;
lines_to_display equ 5
;
CODE    SEGMENT WORD PUBLIC
        assume cs:code,ds:nothing
        org     100h
start:
        jmp     init
        org     110h
                db     'disp addr --->'
disp            dw      0b800h
                db     'display lines->'
lines           db     lines_to_display
                db     'Halt disp ---->'
stop_disp       db      0
                db     'SHOW LC_E0 --->'
show_E0         db      0
                db     'strip/hide --->'
strip_enable    db     00h
                db     'strip char --->'
strip_ch        db     00h
                db     'hide  char --->'
no_show         db     00h
                db     'stg count --->'
stg_cnt         dw     0h
                db     'cmp stg 10 bytes'
cmp_stg         db     16 dup(0)
last_stg        db     16 dup(0)
oldint15        dd      0
high_nibble     db      0
low_nibble      db      0
data_byte       db      0
funct_ah        db      0
old_data        db      0
flags           db      0
last_lines      db      lines_to_display
end_line1       dw      (2*80*lines_to_display)-4
end_line2       dw      (2*80*lines_to_display)-2
;
; New int 15h with (ah) = 4fh
;
my_int_15 proc  far
        IFC     ah NE 4fh AND
        IFC     ah NE 4eh THEN
          jmp     cs:oldint15
        ENDC
;
        IFC     cs:stop_disp NE 0 THEN
          jmp     cs:oldint15
        ENDC
;
; Check to see if the lines to display have changed
;
        push    ax
        mov     al,cs:lines
        mov     ah,cs:last_lines
        IFC ah NE al THEN
          mov   cs:last_lines,al
          mov   cl,160
          mul   cl
          sub   ax,2
          mov   cs:end_line2,ax
          sub   ax,2
          mov   cs:end_line1,ax
        ENDC
        pop     ax
;
; Store last 5 chars in a FIFO
;
        IFC cs:stg_cnt NE 0 THEN
          push  ds
          push  es
          push  ax
          mov   ax,cs
          mov   ds,ax
          mov   es,ax
          mov   ax,word ptr last_stg+1
          mov   word ptr last_stg,ax
          mov   ax,word ptr last_stg+3
          mov   word ptr last_stg+2,ax
          mov   ax,word ptr last_stg+5
          mov   word ptr last_stg+4,ax
          mov   ax,word ptr last_stg+7
          mov   word ptr last_stg+6,ax
          mov   al,last_stg+9
          mov   last_stg+8,al
          pop   ax
          mov   last_stg+9,al
;
; compare string to user string
;
          mov   di,offset last_stg
          mov   si,offset cmp_stg
          mov   cx,stg_cnt
          repe   cmpsb
          IFCC  E THEN
            mov  stop_disp,-1
          ENDC
          pop   es
          pop   ds
        ENDC
;
; Show E0_flag state if enabled
;
        IFC cs:SHOW_E0 NE 0 THEN
          push    ax
          push    ds
          push    es
          mov     ax,cs:disp                    ;Store the ASCII chars in
          mov     ds,ax                         ;..the upper right corner of the
          mov     es,ax
          call    shift_left1
          mov     ax,40h
          mov     es,ax                         ;set (bp) to BIOS data area
          IFT <byte ptr es:[96h]> E 02h THEN
            mov   al,19h                        ;show E0 flag off
          ELSET
            mov   al,18h                        ;show E0 flag on
          ENDT
          mov     ah,71h
          mov     bx,end_line2
          mov     word ptr ds:[bx],ax    ;..display on/off
          pop     es
          pop     ds
          pop     ax
        ENDC

;
; Strip character
;
        IFC cs:strip_enable NE 0 THEN
          IFC al E cs:strip_ch THEN
            push    bp
            mov     bp,sp
            and     word ptr ss:[bp]+6,not 1     ;clear carry
            pop     bp
            iret
          ENDC
;
; check for a no-show character
;
          IFC al E cs:no_show THEN
            push    bp
            mov     bp,sp
            or      word ptr ss:[bp]+6,1         ;set carry
            pop     bp
            jmp     cs:oldint15
          ENDC
         ENDC

;
; Show char received byte converting it to ascii hex and putting it in the
; upper right corner of the screen
;
        push    ds
        push    es
        push    ax
        push    ax
        mov     al,data_byte
        mov     funct_ah,ah                     ;
        mov     cs:old_data,al
        pop     ax
        mov     cs:data_byte,al                 ;save data
        call    xlate_al                        ;convert (al) into ASCII HEX
        mov     cs:high_nibble,ah
        mov     cs:low_nibble,al
        mov     ax,cs:disp                      ;Store the ASCII chars in
        mov     ds,ax                           ;..the upper right corner of the
        mov     es,ax
        call    shift_left2
;
        IFC cs:data_byte E 0F1h THEN            ;check for key switch
          call  shift_left1
        ELSEC
          IFC cs:data_byte E 0F5h OR            ;check for MSR data
          IFC cs:old_data E 0F6h THEN
            call  shift_left1
          ELSEC
            IFC cs:flags E 0 THEN               ;check for beginning of E0 seq.
              IFC cs:data_byte E 0E0h OR
              IFC cs:data_byte E 0E1h OR
              IFC cs:data_byte E 0E2h OR
              IFC cs:old_data E 0F2h OR
              IFT cs:data_byte E 80h THEN
                call    shift_left1
              ENDC
            ELSEC
              IFC cs:flags E 1 AND              ;check fore normal sequence
              IFT cs:data_byte E 80h THEN
                call    shift_left1
              ENDC
            ENDC
          ENDC
        ENDC
;
store_chars:
        IFC cs:data_byte E 0E0h OR
        IFC cs:data_byte E 0E1h OR
        IFC cs:data_byte E 0F0h OR
        IFC cs:data_byte E 0E2h THEN
          mov   cs:flags,2                      ;set E0 or F0 flag bit
        ELSEC
          IFC   cs:flags NE 0 THEN
           dec  cs:flags
          ENDC
          IFC cs:flags E 1 THEN
            IFC cs:data_byte E 0AAh OR
            IFC cs:data_byte E 02Ah THEN
              mov  cs:flags,0
            ENDC
          ENDC
        ENDC
        IFC cs:Funct_ah E 4fh THEN
          mov     ah,40h
        ELSEC
          mov     ah,17h
        ENDC
        mov     al,cs:high_nibble
        mov     bx,end_line1
        mov     word ptr ds:[bx],ax            ;..display
        mov     al,cs:low_nibble
        mov     word ptr ds:[bx+2],ax
;
        pop     ax
        pop     es
        pop     ds
        stc
        jmp     cs:oldint15
my_int_15 endp
;
shift_left2 proc near
          mov     si,4h
          mov     di,0h
          mov     cx,cs:end_line2
          shr     cx,1
          inc     cx
          cld
          rep     movsw
          mov     bx,end_line1
          mov     word ptr ds:[bx],2020h
          mov     word ptr ds:[bx+2],2020h
          ret
shift_left2 endp

shift_left1 proc near
          mov     si,2h
          mov     di,0h
          mov     cx,cs:end_line2
          shr     cx,1
          inc     cx
          inc     cx
          cld
          rep     movsw
          mov     bx,end_line2
          mov     word ptr ds:[bx],2020h
          ret
shift_left1 endp
;
; Translate (AL) to HEX in (AX)
;
hex     DB      '0123456789ABCDEF'
;
xlate_al proc   near
        push    bx
        push    ds
        mov     bx,cs
        mov     ds,bx                           ;setup (ds) equal (cs)
        mov     ah,al
        and     al,0fh                          ;get low nibble
        mov     bx,offset hex                   ;point to xlate table
        xlat                                    ;get ascii value for nibble
        xchg    ah,al                           ;get high nibble
        shr     al,1                            ;...and convert it to
        shr     al,1                            ;...ASCII
        shr     al,1
        shr     al,1
        xlat
        xchg    ah,al
        pop     ds
        pop     bx
        ret
xlate_al endp
;
;---------------------------------------------------------------------
;                                                                    -
;       SHIP_IT                                                      -
;                                                                    -
;       THIS ROUTINE HANDLES TRANSMISSION OF COMMAND AND DATA BYTES  -
;       TO THE KEYBOARD CONTROLLER.                                  -
;                                                                    -
;---------------------------------------------------------------------
;
        assume  ds:data
SHIP_IT PROC    NEAR
        PUSH    AX                      ; SAVE DATA TO SEND

;------- WAIT FOR COMMAND TO BE ACCEPTED
        CLI                             ; DISABLE INTERRUPTS TILL DATA SENT
        SUB     CX,CX                   ; CLEAR TIMEOUT COUNTER
SI0:
        IN      AL,STATUS_PORT          ; READ KEYBOARD CONTROLLER STATUS
        TEST    AL,INPT_BUF_FULL        ; CHECK FOR ITS INPUT BUFFER BUSY
        LOOPNZ  SI0                     ; WAIT FOR COMMAND TO BE ACCEPTED
        POP     AX                      ; GET DATA TO SEND
        OUT     STATUS_PORT,AL          ; SEND TO KEYBOARD CONTROLLER
        STI                             ; ENABLE INTERRUPTS AGAIN
        RET                             ; RETURN TO CALLER
SHIP_IT ENDP
;
;---------------------------------------------------------------------
;                                                                    -
;       SND_DATA                                                     -
;                                                                    -
;       THIS ROUTINE HANDLES TRANSMISSION OF COMMAND AND DATA BYTES  -
;       TO THE KEYBOARD AND RECEIPT OF ACKNOWLEDGEMENTS.  IT ALSO    -
;       HANDLES ANY RETRIES IF REQUIRED                              -
;                                                                    -
;---------------------------------------------------------------------
;
SND_DATA PROC   NEAR
        PUSH    AX                      ; SAVE REGISTERS
        PUSH    BX                      ; *
        PUSH    CX
        MOV     BH,AL                   ; SAVE TRANSMITTED BYTE FOR RETRIES
        MOV     BL,3                    ; LOAD RETRY COUNT
SD0:    CLI                             ; DISABLE INTERRUPTS
        AND     @KB_FLAG_2,NOT (KB_FE+KB_FA+kb_err) ; CLEAR ACK, RESEND and
;                                                   ; error flags
;------- WAIT FOR COMMAND TO BE ACCEPTED
;
        SUB     CX,CX
SD5:    IN      AL,STATUS_PORT
        TEST    AL,INPT_BUF_FULL
        LOOPNZ  SD5                     ; WAIT FOR COMMAND TO BE ACCEPTED
        MOV     AL,BH                   ; REESTABLISH BYTE TO TRANSMIT
        OUT     PORT_A,AL               ; SEND BYTE
        STI                             ; ENABLE INTERRUPTS
        MOV     CX,01A00H               ; LOAD COUNT FOR 10mS+
;
SD1:    TEST    @KB_FLAG_2,KB_FE+KB_FA  ; SEE IF EITHER BIT SET
        JNZ     SD3                     ; IF SET, SOMETHING RECEIVED GO PROCESS
        LOOP    SD1                     ; OTHERWISE WAIT
;
SD2:    DEC     BL                      ; DECREMENT RETRY COUNT
        JNZ     SD0                     ; RETRY TRANSMISSION
        OR      @KB_FLAG_2,KB_ERR       ; TURN ON TRANSMIT ERROR FLAG
        JMP     SHORT SD4               ; RETRIES EXHAUSTED FORGET TRANSMISSION
;
SD3:    TEST    @KB_FLAG_2,KB_FA        ; SEE IF THIS IS AN ACKNOWLEDGE
        JZ      SD2                     ; IF NOT, GO RESEND
;
SD4:    POP     CX                      ; RESTORE REGISTERS
        POP     BX                      ;
        POP     AX                      ; *
        RET                             ; RETURN, GOOD TRANSMISSION
SND_DATA ENDP
;
;---------------------------------------------------------------------
;                                                                    -
;       SND_LED                                                      -
;                                                                    -
;       THIS ROUTINE TURNS ON THE MODE INDICATORS.                   -
;                                                                    -
;---------------------------------------------------------------------
;
SND_LED PROC    NEAR
        CLI                             ; TURN OFF INTERRUPTS
        TEST    @KB_FLAG_2,KB_PR_LED    ; CHECK FOR MODE INDICATOR UPDATE
        JNZ     SL1                     ; DONT UPDATE AGAIN IF UPDATE UNDERWAY
;
        OR      @KB_FLAG_2,KB_PR_LED    ; TURN ON UPDATE IN PROCESS
        MOV     AL,EOI                  ; END OF INTERRUPT COMMAND
        OUT     INTA00,AL               ; SEND COMMAND TO INTERRUPT CONTROL PORT
        JMP     SHORT SL0               ; GO SEND MODE INDICATOR COMMAND
;
SND_LED1:
        CLI                             ; TURN OFF INTERRUPTS
        TEST    @KB_FLAG_2,KB_PR_LED    ; CHECK FOR MODE INDICATOR UPDATE
        JNZ     SL1                     ; DONT UPDATE AGAIN IF UPDATE UNDERWAY
;
        OR      @KB_FLAG_2,KB_PR_LED    ; TURN ON UPDATE IN PROCESS
SL0:    MOV     AL,LED_CMD              ; LED CMD BYTE
        CALL    SND_DATA                ; SEND DATA TO KEYBOARD
        CLI                             ;
        CALL    MAKE_LED                ; GO FORM INDICATOR DATA BYTE
        AND     @KB_FLAG_2,0F8H         ; CLEAR MODE INDICATOR BITS
        OR      @KB_FLAG_2,AL           ; SAVE PRESENT INDICATORS FOR NEXT TIME
        TEST    @KB_FLAG_2,KB_ERR       ; TRANSMIT ERROR DETECTED
        JNZ     SL2                     ;  YES, BYPASS SECOND BYTE TRANSMISSION
;
        CALL    SND_DATA                ; SEND DATA TO KEYBOARD
        CLI                             ; TURN OFF INTERRUPTS
        TEST    @KB_FLAG_2,KB_ERR       ; TRANSMIT ERROR DETECTED
        JZ      SL3                     ; IF NOT, DONT SEND AN ENABLE COMMAND
;
SL2:    MOV     AL,KB_ENABLE            ; GET KEYBOARD CSA ENABLE COMMAND
        CALL    SND_DATA                ; SEND DATA TO KEYBOARD
        CLI                             ; TURN OFF INTERRUPTS
SL3:    AND     @KB_FLAG_2,NOT(KB_PR_LED+KB_ERR) ; TURN OFF MODE INDICATOR
                                        ; UPDATE AND TRANSMIT ERROR FLAG
SL1:    STI                             ; ENABLE INTERRUPTS
        RET                             ; RETURN TO CALLER
SND_LED ENDP
;
;---------------------------------------------------------------------
;                                                                    -
;       MAKE_LED                                                     -
;                                                                    -
;       THIS ROUTINE FORMS THE DATA BYTE NECESSARY TO TURN ON/OFF    -
;         THE MODE INDICATORS                                        -
;                                                                    -
;---------------------------------------------------------------------
;
MAKE_LED PROC   NEAR
        PUSH    CX                      ; SAVE CX
        MOV     AL,@KB_FLAG             ; GET CAPS & NUM LOCK INDICATORS
        AND     AL,CAPS_STATE+NUM_STATE+SCROLL_STATE ; ISOLATE INDICATORS
        MOV     CL,4                    ; SHIFT COUNT
        ROL     AL,CL                   ; SHIFT BITS OVER TO TURN ON INDICATORS
        AND     AL,07H                  ; MAKE SURE ONLY MODE BITS ON
        POP     CX
        RET                             ; RETURN TO CALLER
MAKE_LED ENDP
;
; Initialize code.  Thrown away after loaded
;
init:   push    ds
        push    es
        mov     ax,0
        mov     ds,ax
        les     bx,ds:[15H*4]
        mov     word ptr cs:oldint15,bx
        mov     word ptr cs:oldint15+2,es
        cli
        mov     word ptr ds:[15H*4],offset my_int_15
        mov     ds:[15H*4+2],cs
        sti
        mov     dx,offset init
        pop     es
        pop     ds
        int     27h
CODE    ENDS
        END     start
